###############################################################################
# Display.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Software Version: YaBB 1 Gold - SP1                                         #
# Released: December 2001                                                     #
# =========================================================================== #
# Software Distributed by:    http://yabb.xnull.com                           #
# Support, News, Updates at:  http://yabb.xnull.com/community/                #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$displayplver = "1 Gold - SP1";

sub Display {
    my($msf,$mfn,$attachment,$showattach);
	my $viewnum = $INFO{'num'};
	if( $viewnum =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	$maxmessagedisplay ||= 10;
	my($buffer,$views,$lastposter,$moderators,$counter,$counterwords,$pageindex,$msubthread,$mnum,$mstate,$mdate,$msub,$mname,$memail,$mreplies,$musername,$micon,$noposting,$threadclass,$notify,$max,$start,$bgcolornum,$windowbg,$mattach,$mip,$mlm,$mlmb,$lastmodified,$postinfo,$star,$sendm,$topicdate);
	my(@userprofile,@messages,@bgcolors);
	my($mystatus);
	my(@statussettings);

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$curcat = <FILE>;
	fclose(FILE);
	#$curcat = $cat;
	fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	# Load the membergroups list.
	fopen(FILE, "$vardir/membergroups.txt") || &fatal_error("100 $txt{'106'}: $txt{'23'} membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);

	# Mark current thread as read.
	## LAST READ MOD ##
 	($mnum,$tmpa,$tmpa,$tmpa,$mdate,$mreplies) = split(/\|/,$yyThreadLine);
 	$mreplies++;
 	&dumplog($mnum,$mdate,$mreplies);
	## /LAST READ MOD ##

	# Add 1 to the number of views of this thread.
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
	elsif( -e "$datadir/$viewnum.data" ) { &fatal_error("102 $txt{'106'}: $txt{'23'} $viewnum.data"); }
	else { $tmpa = '0'; }
	($tmpa, $tmpb) = split( /\|/, $tmpa );
	$tmpa++;
	fopen(FILE, "+>$datadir/$viewnum.data") || &fatal_error("103 $txt{'106'}: $txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb~;
	fclose(FILE);
	$views = $tmpa - 1;

	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );
	$noposting = $viewnum eq $mnum && $mstate == 1 ? 1 : 0;

	# Get the class of this thread, based on lock status and number of replies.
	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'};start=$start">$img{'reply'}</a>~;
	$threadclass = 'thread';
	if( $mstate == 1 ) {
		$threadclass = 'locked';
		$replybutton = "";
	}
	elsif( $mreplies > 49 ) { $threadclass = 'flamingthread'; }
	elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
	elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
	elsif( $mstate == 0 ) { $threadclass = 'thread'; }
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	fclose(FILE);
	foreach $curnum (@stickys) {
		if ($mnum == $curnum) {
			if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
			else { $threadclass = 'sticky'; }
		}
	}

	&LoadCensorList;	# Load Censor List

	# Build a list of this board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
	&jumpto;	# create the jumpto list

	# Build the page links list.
	$postdisplaynum = 3;	# max number of pages to display
	$max = $mreplies + 1;
	$start = $INFO{'start'} || 0;
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$tmpa = 1;
	$tmpx = int( $max / $maxmessagedisplay );
	if ($start >= (($postdisplaynum-1) * $maxmessagedisplay)) { $startpage = $start - (($postdisplaynum-1) * $maxmessagedisplay); $tmpa = int( $startpage / $maxmessagedisplay ) + 1; }
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxmessagedisplay) { $pageindex = qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=display;num=$viewnum;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $maxmessagedisplay;
	$outerpn = int($tmpx / $maxmessagedisplay) + 0;
	$lastpn = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn = ($lastpn - 1) * $maxmessagedisplay;
	if ($endpage < $max - ($maxmessagedisplay) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=display;num=$viewnum;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$msubthread =~ s~\Q$tmpa\E~$tmpb~gi;
	}	
	$curthreadurl = $curposlinks ? qq~<a href="$cgi;action=display;num=$viewnum" class="nav">$msubthread</a>~ : $msubthread;
	# Begin addon for boardlinksSP1
	$blink = '';
	$i=0;
	$ii=0;
	while($LinkBoard[$i]) {
		if ($LinkBoard[$i] eq $currentboard){
			if ($ii == 0){
				$blink .= qq~<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
				$ii=1;
			} else {
				$blink .= qq~$blinkstxt{'13'}<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
			}
		}
		$i++;
	}
	if ($blink ne ''){
		$blink = qq~<table width="100%" cellpadding=3 cellspacing=0><TD align="center" class="catbg" bgcolor="$color{'titletext'}"><font size=2>$blinkstxt{'12'}$boardname</font><BR>$blink</TD></table><BR><BR>~;
	}
	if ($boardlinks != 1) {$yymain .= "$blink";}
# End addon for boardlinksSP1

	# Create next/prev links
	fopen(LISTS, "$boardsdir/$INFO{'board'}.txt");
	@boardtopics = <LISTS>;
	seek LISTS, 0, 0;
	my $found;
	my $name = $INFO{'num'};
	my $bcount = 0;
	$CurrentPosition = -1;
	while($ThreadNum = <LISTS>) {
		++$CurrentPosition;
		$boardtopics[$bcount] = $ThreadNum;
		$bcount++;
		if ($ThreadNum =~ m/\A$name/o) { $found = 1; last; }
	}
	fclose(LISTS);
	$previous = $boardtopics[$CurrentPosition-1];
	$next = $boardtopics[$CurrentPosition+1];
	@prevthread = split(/\|/, $previous);
	$goprevious = $prevthread[0];
	@nextthread = split(/\|/, $next);
	$gonext = $nextthread[0];
	@getlastthread = @boardtopics;
	$lastthread = pop(@getlastthread);
	@lasttopic = split(/\|/, $lastthread);
	$endthread2 = $lasttopic[0];
	if($found) {
		$prevtopic = "$cgi;action=display;num=$goprevious";
		$nexttopic = "$cgi;action=display;num=$gonext";
		$endthread = "$cgi;action=display;num=$endthread2";
	}
	if( $endthread eq $prevtopic && $gonext eq "") { $nav = qq~&#171; $txt{'766'} | $txt{'766'} &#187;~; }
	if($endthread eq $prevtopic && $gonext ne "") { $nav = qq~&#171; $txt{'766'} | <a href="$nexttopic">$txt{'767'}</a> &#187;~; }
	if ( $endthread ne $prevtopic && $gonext eq "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | $txt{'766'} &#187;~; }
	if ($endthread ne $prevtopic && $gonext ne "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | <a href="$nexttopic">$txt{'767'}</a> &#187;~; 	}
	$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<object classid="clsid:F3A614DC-ABE0-11d2-A441-00C04F795683" codebase="#Version=2,0,0,83" codetype=application/x-oleobject id=MsgrObj width=0 height=0>
</object>
<OBJECT classid="clsid:FB7199AB-79BF-11d2-8D94-0000F875C541" codeType=application/x-oleobject id=MsgrApp width=0 height=0></OBJECT>
<SCRIPT LANGUAGE="JavaScript">           
<!--            
function stopError() {             return true;           }            
window.onerror = stopError;            
// -->
</script>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td valign=bottom colspan="2"><font size="2" class="nav"><B>
    <img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a> </b><font size="1">$showmods</font><b><br>
    <img SRC="$imagesdir/tline3.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    $curthreadurl</b></font></td>
    <td valign="bottom" align="right"><font size="1">$nav</font></td>
  </tr>
</table>
<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><a name="top"></a><font size="2"><b>$txt{'139'}:</b> $pageindex<b>.: </b><a href="#bot"><b>ŧҹҧ</b></a><b> :. </b></font>
        </td>
            <td class="catbg" bgcolor="$color{'catbg'}" align="right" width="350"><font size="2">
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;

	# Look for a poll file for this thread.
	
	if (-e "$datadir/$viewnum.poll") { $pollthread = 1; }
	
if ($pollthread) {
	fopen (FILE, "$datadir/$viewnum.poll");
		@polldata = <FILE>;
	fclose (FILE);

	$pollquestion = $polldata[0];
	$pollquestion =~ s~\n~~g;
	($question, $lockstatus) = split(/\|/, $pollquestion);
	$num = 1;
	$line = 0;
	my @options;
	my @votes;
	foreach $pointer (@polldata) {
		($vote, $option) = split(/\|/, $polldata[$num]);
		$options[$line] = $option;
		$votes[$line] = $vote;
		$line++;
		$num++;
	}
	
	$search = -1;
	my $found;
	$usersemail = $settings[2];
	$userstatus = $settings[7];
	$found = &CheckVoted($viewnum); 
	
	if ($found) { $userhasvoted = 1; }
	$viewresults = $INFO{'viewresults'};
	if ($lockstatus eq "Locked") { $pollislocked = 1; }
	
	if ($username ne "Guest" && ($username eq $susername) || ($userstatus eq "Administrator" or $userstatus eq "Global Moderator" or exists $moderators{$username})) { $modifypoll = qq~<a href="$cgi;action=modify;message=0;thread=$viewnum" class="altlink"><img src="$imagesdir/modify.gif" border="0">$polltxt{'39'}</a>&nbsp;~; }
	if (($userstatus eq "Administrator" || $userstatus eq "Global Moderator" || exists $moderators{$username}) && ($pollislocked ne 1)) { $lockpoll = qq~<a href="$cgi;action=lockpoll;num=$viewnum" class="altlink">$img{'polliconclosed'} $polltxt{'20'}</a>&nbsp;~; }
	if (($userstatus eq "Administrator" || $userstatus eq "Global Moderator" || exists $moderators{$username}) && ($pollislocked eq 1)) { $lockpoll = qq~<a href="$cgi;action=unlockpoll;num=$viewnum" class="altlink">$img{'polliconclosed'} $polltxt{'21'}</a>&nbsp;~; }
	if ($userstatus eq "Administrator"){ $displayvoters = qq~<a href="$cgi;action=showvoters;num=$viewnum" class="altlink"><img src="$imagesdir/register.gif" border="0"> $polltxt{'33'}</a>~;}
	$vresults = qq~<a href="$cgi;action=display;num=$viewnum;viewresults=yes" class="altlink">$polltxt{'19'}</a>~;
	if ($pollislocked eq 1) { $endedtext = $polltxt{'22'}; }


	$poll_icon = qq~$img{'pollicon'}~;
	if ($pollislocked == 1) { $poll_icon = qq~$img{'polliconclosed'}~; }

	$yymain.= qq~<table border="0" width="100%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="20%"><font size=2 class="text1" color="$color{'titletext'}">&nbsp;$poll_icon <b>$polltxt{'15'}</b></font></td>
    <td valign="middle" align="center" bgcolor="$color{'titlebg'}" class="titlebg" width="45%"><font size=2 class="text1" color="$color{'titletext'}"><b>$endedtext</b></font></td>
    <td valign="middle" align="right" bgcolor="$color{'titlebg'}" class="titlebg" width="35%"><font size=1 color="$color{'titletext'}">$lockpoll &nbsp; $displayvoters &nbsp; $modifypoll</font></td>
 </tr><tr>
    <td colspan="3" valign="top" align="center" bgcolor="$color{'windowbg2'}" class="windowbg2">
~;
	# Censor the question.
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$question =~ s~\Q$tmpa\E~$tmpb~gi;
	}

	if (($userhasvoted) || $viewresults eq 'yes' || $pollislocked eq 1 ) {
	
		
		$yymain.= qq~
      <table border="0" width="100%" cellspacing="0" cellpadding="5" bgcolor="$color{'windowbg2'}" class="windowbg2">
        <tr valign="top">
          <td><font size="2"><b>$polltxt{'16'}:</b>  $question</font><br><br></td>
        </tr>
        <tr> 
          <td align="center">
            <table border="0" cellspacing="0" cellpadding="0">~;
		$nums = 0;
    
		my $Key; 
		my $Total; 
		$maxvote = 0;
		foreach $Key (@votes) { 
			$Total += $Key; 
			if ($Key >= $maxvote) { $maxvote = $Key;}
		} 

		$totalvotes = $Total;
		pop (@options);
		foreach (@options) {

			# Censor the options.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$message = $options[$nums]; # put the message back into the proper variable to do ubbc on it
			if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &MakeSmileys;
			$options[$nums] = $message;
			$options[$nums] =~ s~\n~~g;
			$options[$nums] =~ s~<br>~~g;
			$yymain .= qq~
              <tr> 
                <td><b><font size="2">$options[$nums]</font></b></td>
                <td width="250">~;

# Now lets calculate how many devisions by the total number of votes are needed to make the bar graphs stay nicely sized in the browser window:

			$pollpercent = 0;
			$pollbar = 0;
			if ($totalvotes ne 0 && $maxvote ne 0) {
				$pollpercent = int(1000 * $votes[$nums] / $totalvotes);
				$pollpercent = $pollpercent / 10; 
				$pollbar = int( 150 * $votes[$nums] / $maxvote);
			}
    
			$yymain .= qq~&nbsp;&nbsp;<img src="$imagesdir/poll_left.gif" align="middle"><img src="$imagesdir/poll_middle.gif" height="12" width="$pollbar" align="middle"><img src="$imagesdir/poll_right.gif" align="middle"> <font size="2">$votes[$nums] ($pollpercent%)</font></td>
              </tr>~;
			$nums++;
		}

		$yymain .= qq~
            </table>
            <br><b><font size="2">$polltxt{'17'}: $totalvotes</font></b>
          </td>
        </tr>
      </table>
~;
	}
	else {
		$board = $INFO{'board'};
		$yymain.= qq~
      <form name="poll" method="post" action="$cgi;action=vote;board=$board;num=$viewnum">
        <table border="0" width="100%" cellspacing="0" cellpadding="5">
          <tr valign="top"> 
            <td><font size="2"><b>$polltxt{'16'}:  </b>$question</font></td>
          </tr>
          <tr> 
            <td align="center">
              <table width="90%" border="0" cellspacing="0" cellpadding="0">~;
		$nums = 0;
		pop (@options);
		foreach (@options) {
			# Censor the options.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$options[$nums] =~ s~\n~~g;
			$options[$nums] =~ s~<br>~~g;
			$message = $options[$nums]; # put the message back into the proper variable to do ubbc on it
			if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &MakeSmileys;
			$options[$nums] = $message;
			$yymain .= qq~
                <tr valign="top"> 
                  <td width="5%"><INPUT type="radio" name="option" value="$nums"></td>
                  <td width="95%" valign="middle"><font size="2">$options[$nums]</font></td>
                </tr>~;
			$nums++;
  		}
		$yymain .= qq~
              </table>
            </td>
          </tr>
          <tr>
            <td align="center"><INPUT type="submit" value="$polltxt{'18'}"><br><font size="2">$vresults</font></td>
          </tr>
        </table>
      </form>
~;
	}
$yymain .= qq~
    </td>
  </tr>
</table>~;	
}
$yymain .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
        <font size=2 class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="">
        &nbsp;<b>$txt{'29'}</b></font></td>
        <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%">
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;

	# Load background color list.
	@bgcolors = ( $color{windowbg}, $color{windowbg2} );
	$bgcolornum = scalar @bgcolors;
	@cssvalues = ( "windowbg","windowbg2" );
	$cssnum = scalar @bgcolors;

	if(!$MenuType) { $sm = 1; }
	$counter = 0;

	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <FILE>)) { $counter++; }

	$#messages = $maxmessagedisplay - 1;
	for($counter = 0; $counter < $maxmessagedisplay && ($buffer = <FILE>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);
	$#messages = $counter - 1;
	$counter = $start;

	# For each post in this thread:
	foreach (@messages) {
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css = $cssvalues[($counter % $cssnum)];
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb, $msf, $mfn) = split(/[\|]/, $_);
		# Should we show an attachment file?
			if( $msf && $mfn && $msf ne "" && $mfn ne "") {
			if (-e ("$upload_dir/$mfn")) {
			$attachment = qq~<font size="1"><a href="$msf" target="_blank"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn</a></font>~;
				if(($mfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) {
					$showattach = qq~<hr width="100%"><center><img src="$msf" alt"$msf" border="0"></center>~;
				} else { 
					$showattach = ''; 
				}
			} else { 
				$attachment = qq~<font size="1"><img src="$imagesdir/paperclip.gif" border="0" align="absmiddle">  $mfn $fatxt{'1'}</font>~;
				$showattach = '';
			}
		} else {
			$attachment = '';
			$showattach = '';
		}

		$lastmoduser = $mlmb;
		# Should we show "last modified by?"
		if( $mlm && $showmodify && $mlm ne "" && $mlmb ne "" && $mlmb ne "admin") {
			$mlm = &timeformat($mlm);
			&LoadUser($mlmb);
			$mlmb = $userprofile{$mlmb}->[1] || $mlmb || $txt{'470'};
			$lastmodified = qq~&#171; <i>$txt{'211'}: $mlm $txt{'525'} $mlmb</i> &#187;~;
		}
		else {
			$mlm = '-';
			$lastmodified = '';
		}
		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);
		if ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' && $allow_mod == 1) { $mip = $mip } else { $mip = "$txt{'511'}"; }
		$sendm = '';

		# If the user isn't a guest, load his/her info.
		$online = "";
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		my($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispflag);
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
			if($view_flag) {
		($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy) = split(/\|/, $userprofile[15]);
		if($dispcountry ne "") {
			if($loccode eq "x1") { $dispflag = qq~<a href="$scripturl?board=$currentboard;action=mmview;username=$useraccount{$musername}"><img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0></a>~; }
			elsif($loccode eq "x0") { $dispflag = qq~<img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0>~; }
			else { $dispflag = ""; }
		}
	}
			fopen(NUMBERFILEREAD,"$memberdir/$musername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if ($musername eq "admin") { $displaynumb = ''; }
			else { $displaynumb = qq~$membtxt{'23'} $number[0]~; }
			$star = $memberstar{$musername};
			$memberinfo = $memberinfo{$musername};
			$memberinfo =~ s~\n~~g;
			$icqad = $icqad{$musername};
			$yimon = $yimon{$musername};
			if($username ne 'Guest') {
				# Allow instant message sending if current user is a member.
				$sendm = qq~$menusep<a href="$cgi;action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
			}
			$usernamelink = $link{$musername};
			$postinfo = qq~$txt{'26'}: $userprofile[6]<br>~;
			$memail = $userprofile[2];
			### Begin HTML MOD
			if ($postmessage =~ /\#enable_html/isg) {
				$html_username = $musername;
				if ($lastmoduser ne $html_username && $lastmoduser ne '') {
					$html_username = $lastmoduser;
				}
				$message_backup = $postmessage; # since $message is no local variable, it often gets overwritten accidently somehwere (couldn't find out where)
				$enable_html = HTML_allow($html_username);
				$postmessage = $message_backup;
				if ($enable_html == 1) { $postmessage =~ s/\#enable_html//isg; }
			} else { $enable_html = 0; }
			### End HTML MOD
			$online = "";
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			$online = qq~<font size="1"><font color="#FF0000">(offline)</font></font>~;
			foreach $curentry (@entries) {
			chomp $curentry;
			($name, $value) = split(/\|/, $curentry);
			if( $name eq $musername) 
					{
					$online = qq~<font size="1"><font color="#33FF00">(<b>Online</b>)</font></font>~;	
					}
			}
			
		}
		else {
			$musername = "Guest";
			$displaynumb = '';
			$star = '';
			$memberinfo = "$txt{'28'}";
			$icqad = '';
			$yimon = '';
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			if ($memberinfo eq "$txt{'28'}") { $usernamelink = qq~<font size="2"><b>$mname<br></b></font>~; }
			$postinfo = '';
			@userprofile = ();
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		# Run UBBC interpreter on the message.
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc && $enable_html != 1) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>$menusep~ : '';
		if($counter != 0) { $counterwords = "$txt{'146'} #$counter"; }
		else { $counterwords = ""; }
		if($enable_html == 1) { &FromHTML($message); }
		# Print the post and user info for the poster.
	# Chat Bubbles! 1.5
	# This code determines if the current board is one
	# that needs to be displayed in chat bubbles.
	$dobubbles = '0';
	my( @bubbles, $i );
	fopen(FILE, "$vardir/chatbubbles.txt");
	@bubbles = <FILE>;
	fclose(FILE);
	foreach $i (@bubbles) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
		if ($i eq $currentboard) {
			$dobubbles = '1';
		}
	}
	# Chat Bubbles display code
if ($dobubbles eq '1') {		
	if ((($counter % 2) == '0')||($counter == '0')) {
		$yymain .= qq~
<a name="$counter">
      <table cellpadding=0 cellspacing=0 border=0 width="100%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr><td>
      <table cellpadding=0 cellspacing=0 border=0 width="96%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr> 
    <td valign="top"> 
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td width="100%"><font size=1>$usernamelink</font></a> 
          </td>
        </tr>
        <tr>
          <td width="100%"><font size=1>
            <center>~;
	if($musername ne "Guest") {
		$yymain .= qq~
		~;
	if($view_flag) {
	$yymain .= qq~
		$dispflag<br>
~;
	}
	$yymain .= qq~
            $userprofile[13]
            $memberinfo<BR>
            $userprofile[12]
            $userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;
	}
	if($musername eq "Guest") {
		if($memail ne "") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
		}
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
	$yymain .= qq~
            $userprofile[11]
            $postinfo
            </font>
          </td>
        </tr>
      </table>
    </td>    
    <td width="100%" valign="top">   
      <table border="0" cellpadding="0" cellspacing="0" width="100%">   
        <tr>   
          <td></td>   
          <td><img border="0" src="$imagesdir/huki1.gif" width="14" height="14"></td>   
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td>   
          <td><img border="0" src="$imagesdir/huki2.gif" width="14" height="14"></td>   
        </tr>   
        <tr>   
          <td valign="top"><img border="0" src="$imagesdir/huki5.gif" width="30" height="30"></td>  
          <td bgcolor="#FFFFFF"> </td>
          <td bgcolor="#FFFFFF" width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td width="100%">            <table width='100%' border='0'> 
              <tr> 
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif"></td> 
                <td align="left" valign="middle"> 
                <font size="2"><B>$msub</b></font><BR>   
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>   
                <td align="right" valign="bottom" nowrap height="20">   
                <font size=-1> $menusep<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>   
~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
		$yymain .= qq~  $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1">$img{'delete'}</a></font>~;
	}

	$yymain .= qq~
                </td>   
              </tr>   
            </table> </td>  
              </tr>  
              <tr>  
                <td width="100%"> 
                  <hr size="1">
            	        <font size="2">$message</font>
                </td> 
              </tr> 
              <tr> 
                <td width="100%"><font size="1">$userprofile[5]</font>  
                </td> 
              </tr> 
            </table></td> 
          <td bgcolor="#FFFFFF"> </td> 
        </tr> 
        <tr> 
          <td></td> 
          <td><img border="0" src="$imagesdir/huki4.gif" width="14" height="14"></td> 
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td> 
          <td><img border="0" src="$imagesdir/huki3.gif" width="14" height="14"></td> 
        </tr> 
      </table> 
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td width="50%"></td>
          <td width="50%" align="right">
           <font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font>
          </td> 
        </tr> 
      </table>
          </td></tr></table> &nbsp;
    </td> 
  </tr> 
  </table>
~;
}

elsif (($counter % 2) != '0') {
		$yymain .= qq~
<a name="$counter">
      <table cellpadding=0 cellspacing=0 border=0 width="100%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr><td>
      <table cellpadding=0 cellspacing=0 border=0 width="96%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr> 
    <td width="100%" valign="top">   
      <table border="0" cellpadding="0" cellspacing="0" width="100%">   
        <tr>   
          <td><img border="0" src="$imagesdir/huki1.gif" width="14" height="14"></td>   
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td>   
          <td><img border="0" src="$imagesdir/huki2.gif" width="14" height="14"></td>   
          <td></td>   
        </tr>   
        <tr>   
          <td bgcolor="#FFFFFF"> </td>
          <td bgcolor="#FFFFFF" width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td width="100%">            <table width='100%' border='0'> 
              <tr> 
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif"></td> 
                <td align="left" valign="middle"> 
                <font size="2"><B>$msub</b></font><BR>   
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>   
                <td align="right" valign="bottom" nowrap height="20">   
                <font size=-1> $menusep<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>   
~;
		if(exists $moderators{$username} || $settings[7] eq 'Administrator') {
$yymain .= qq~
                $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1">$img{'delete'}</a></font>
~;
}
$yymain .= qq~
                </td>   
              </tr>   
            </table> </td>  
              </tr>  
              <tr>  
                <td width="100%"> 
                  <hr size="1">
            	        <font size="2">$message</font>
                </td> 
              </tr> 
              <tr> 
                <td width="100%"><font size="1">$userprofile[5]</font>  
                </td> 
              </tr> 
            </table></td> 
          <td bgcolor="#FFFFFF"> </td> 
          <td valign="top"><img border="0" src="$imagesdir/huki6.gif" width="30" height="30"></td>  
        </tr> 
        <tr> 
          <td><img border="0" src="$imagesdir/huki4.gif" width="14" height="14"></td> 
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td> 
          <td><img border="0" src="$imagesdir/huki3.gif" width="14" height="14"></td> 
          <td></td> 
        </tr> 
      </table> 
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td width="50%" align="left"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
          <td width="50%"></td> 
        </tr> 
      </table> 
          </td>
              <td valign="top"> 
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td width="100%"><font size=1>$usernamelink</font></a> 
            </font></td>
        </tr>
        <tr>
          <td width="100%"><font size=1>
            <center>~;
	if($musername ne "Guest") {
		$yymain .= qq~
		~;
	if($view_flag) {
	$yymain .= qq~
		$dispflag<br>
~;
	}
	$yymain .= qq~
            $userprofile[13]
            $memberinfo<BR>
            $userprofile[12]
            $userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;
	}
	if($musername eq "Guest") {
		if($memail ne "") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
		}
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
	$yymain .= qq~
            $userprofile[11]
            $postinfo
            </font>
          </td>
        </tr>
      </table>   <br>
    </td>    </tr></table> &nbsp;
    </td> 
  </tr> 
  </table>
~;
}
}
	# If it's not to be displayed as chat bubbles,
	# then use the normal, default display
	else {
		$yymain .= qq~
<a name="$counter"></a>
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$windowbg" class="$css">
        <table width='100%' cellpadding='4' cellspacing='0' class="$css" bgcolor="$windowbg">
          <tr>
            <td class="$css" bgcolor="$windowbg" valign="top" width="20%" rowspan="2"><font size="1">
            $usernamelink $online<BR>
            $memberinfo<BR>~;
	if($musername ne "Guest") {
		$yymain .= qq~
		~;
	if($view_flag) {
	$yymain .= qq~
		$dispflag<br>
~;
	}
	$yymain .= qq~
            $star<BR>
~;
if ($view_numb) {
	$yymain .= qq~
		$displaynumb<BR><BR>
	~;
}
else {
	$yymain .= qq~
		<BR>
	~;
}
$yymain .= qq~
           <center>$userprofile[13]$userprofile[12]</center><BR>
           $userprofile[8] $icqad &nbsp;~;
	fopen(FILE, "$memberdir/$useraccount{$musername}.om", 1); 
        @msnsettings = <FILE>;
        fclose <FILE>;
        chomp @msnsettings;   
            if ($msnsettings[0] ne '')
            {
$yymain .= qq~
           <a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="Chat to $msnsettings[0]" border=0></a> &nbsp; 
           <a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="Add $msnsettings[0] to your Buddy List" border=0></a> &nbsp;~;
        }
$yymain .= qq~
            $userprofile[10] $yimon &nbsp; $userprofile[9]</center><BR>
~;
	}
	if($musername eq "Guest") {
		if($memail ne "") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
		}
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $settings[7] eq "Global Moderator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
	$yymain .= qq~
            $userprofile[11]
            $postinfo
			<br>$exp{$musername}
            </font></td>
            <td class="$css" bgcolor="$windowbg" valign="top" width="80%" height="100%">
            <table width='100%' border='0'>
              <tr>
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif" alt=""></td>
                <td align="left" valign="middle">
                <font size="2"><B>$msub</b></font><BR>
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B>$messdate &#187;</font><BR>$attachment</td>
                <td align="right" valign="bottom" nowrap height="20">
                <font size=-1>
~;
############################
	## My Status Mod by Sonic ##
	############################
if ($showstatus) { 
               fopen(FILE, "$memberdir/$musername.status");
 	@statussettings=<FILE>;
	fclose(FILE);
	$mystatus=@statussettings[0];
	if ($mystatus eq '0') { $memstatus =$status{'4'} ; }
	elsif ($mystatus eq '1') { $memstatus =$status{'5'} ; }
	elsif ($mystatus eq '2') { $memstatus =$status{'6'} ; }
	else { $memstatus =$status{'7'} ; }
	if ($memstatus ne $status{'7'}) {
	$userprofile[5]=qq~<hr>$status{'3'} <b>$memstatus</b>$userprofile[5]~; }
	else {
	$userprofile[5]=qq~$userprofile[5]~;
	}
}
	################################
	## / My Status Mod by Sonic / ##
	################################
if ($mstate != 1)
{
$yymain .= qq~
                <a href="$cgi&action=reporttm&thread=$viewnum&id=$counter&subject=$msub&poster=$mname&username=$musername&email=$memail"><img src="$imagesdir/rtm.gif" alt="$rtm{'22'}" border="0"> <font size="1" class="imgwindowbg">$rtm{'22'}</font></a>
                $menusep
                <a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>
~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername || $settings[7] eq 'Global Moderator') {
		$yymain .= qq~  $menusep<a href="javascript:DoConfirm('$txt{'739'}','$cgi;action=modify2;thread=$viewnum;id=$counter;d=1')">$img{'delete'}</a>~;
	}
}
	$yymain .= qq~
                </font></td>
              </tr>
            </table>
            <hr width="100%" size="1" class="hr">
            <font size="2">
            $message
            </font>
            </td>
          </tr><tr>
            <td class="$css" bgcolor="$windowbg" valign="bottom">
            <table width="100%" border="0">
              <tr>
                <td align="left"><font size="1">$lastmodified</font></td>
                <td align="right"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
              </tr>
            </table>
			$showattach
            <font size="1">
            $userprofile[5]
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>~;
		}
	# end changes by Chat Bubbles! 1.5
		$counter++;
	}
	if($settings[7] eq 'Administrator') {
$sadminf = qq(<b>$img{'admin_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	if(exists $moderators{$username} && $settings[7] ne 'Administrator' || $settings[7] eq 'Global Moderator') {
$sadminf = qq(<b>$img{'moderator_func'}</b> &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a><a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a><a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a><a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>);
}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><a name="bot"></a><font size=2><b>$txt{'139'}:</b> $pageindex<b> .: </b><a href="#top"><b>Ѻҹ</b></a><b> :. </b></font>
        </td>
            <td class="catbg" bgcolor="$color{'catbg'}" align=right width="350"><font size=2>
            $replybutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
<table border="0" width="100%" cellpadding="0" cellspacing="0">~;
	  $yymain .= qq~
  <tr>
    <td align="left" valign="top" colspan="2">~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
		$yymain .= qq~<font size="1">$sadminf</font>~;
	}
	$yymain .= qq~
    </td>
    <td valign="top" height="18" align="right"><font size="1">$selecthtml</font></td>
  </tr><tr>
    <td colspan="3" valign="top" align="right"><font size="1">$nav</font></td>
  </tr>
</table>
~;
	if ($username ne "Guest" && $mstate != 1 && $enable_quickreply == 1) {
$yymain .= qq~
<form action="$cgi;action=post2" method="post" name="postmodify">
<input type="hidden" name="threadid" value="$viewnum">
<input type="hidden" name="icon" value="xx">
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'172a'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="Quick Re: $msubthread" size="40" style="width:100%"></td>
        </tr>
~;
		if ($enable_quicksmilies == 1) {
$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
              document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align='bottom' alt='$txt{'287'}' border='0'></a> ");
              document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align='bottom' alt='$txt{'292'}' border='0'></a> ");
              document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align='bottom' alt='$txt{'289'}' border='0'></a> ");
              document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align='bottom' alt='$txt{'293'}' border='0'></a> ");
              document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align='bottom' alt='$txt{'288'}' border='0'></a> ");
              document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align='bottom' alt='$txt{'291'}' border='0'></a> ");
              document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align='bottom' alt='$txt{'294'}' border='0'></a> ");
              document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align='bottom' alt='$txt{'295'}' border='0'></a> ");
              document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align='bottom' alt='$txt{'296'}' border='0'></a> ");
              document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align='bottom' alt='$txt{'450'}' border='0'></a> ");
              document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align='bottom' alt='$txt{'451'}' border='0'></a> ");
              document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align='bottom' alt='$txt{'526'}' border='0'></a> ");
              document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align='bottom' alt='$txt{'527'}' border='0'></a> ");
              document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align='bottom' alt='$txt{'528'}' border='0'></a> ");
              document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align='bottom' alt='$txt{'529'}' border='0'></a> ");
              document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align='bottom' alt='$txt{'530'}' border='0'></a> ");
            }
            else { document.write("<font size='1'>$txt{'215'}</font>"); }
          //-->
          </script>
          <noscript>
            <font size="1">$txt{'215'}</font>
          </noscript>
          </td>
        </tr>
~;
		}
$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" style="width:100%"></textarea></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="$post" value="$txt{'105'}" accesskey="s"> &nbsp; <input type="reset" value="$txt{'278'}" accesskey="r"></td>
  </tr>
</table>
</form>
~;
	}
	$yytitle = $msubthread;
	if ($boardlinks == 1) {$yymain .= "$blink";}
	&template;
	exit;
}

1;